!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Program ArareInit
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: init.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!$BHs@ENO3X%b%G%k(B deepconv/arare $B$N=i4|CM$r:n@.$9$k(B. 
!$B=i4|CM%U%!%$%k$K$O(B 2 $B%9%F%C%WJ,$N%G!<%?$,I,MW$J$N$G(B, 
!$B:G=i$N(B 1 $B%9%F%C%W$r%*%$%i!<K!$G7W;;$9$k(B
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
! *$BJ}Dx<07O$O=`05=L7O(B.
!
!== Future Plans
!
                                                                 !=end

program ArareInit
                                                                 !=begin
  !== Dependency
  use dc_trace,   only: BeginSub, EndSub, DbgMessage
  use dc_message
  use debugset,   only: debugset_init, DebugOn
  use gridset,    only: gridset_init, DimXMin, DimXMax, DimZMin, DimZMax, &
       &                RegZMin, RegZMax
  use fileset,    only: fileset_init, cfgfile, ReStartFile
  use timeset,    only: timeset_init, NstepShort, DelTimeLong, DelTimeShort
  use nameset,    only: nameset_init
  use physset,    only: physset_init  
  use linlib,     only: linlib_init
  use bcset,      only: bcset_init
  use arareset,   only: arareset_init
  use basicset,   only: basicset_calc_init, &
       &                ss_MixRtVBasicZ,              &
       &                ss_MixRtCBasicZ,              &
       &                ss_MixRtRBasicZ
  use disturbset, only: disturbset_calc_init, &
       &                ss_ExnerDisturb, ss_PotTempDisturb, &
       &                fs_VelXDisturb,  sf_VelZDisturb,    &
       &                ss_MixRtVDisturb,              &
       &                ss_MixRtCDisturb,              &
       &                ss_MixRtRDisturb
                                                                 !=end
  implicit none

  real(8), allocatable  :: ss_Exner_as(:,:)
  real(8), allocatable  :: fs_VelX_as(:,:)
  real(8), allocatable  :: sf_VelZ_as(:,:)
  real(8), allocatable  :: ss_Exner_ns(:,:)
  real(8), allocatable  :: fs_VelX_ns(:,:)
  real(8), allocatable  :: sf_VelZ_ns(:,:)

  real(8), allocatable  :: fs_AdvDiffX_nl(:,:)
  real(8), allocatable  :: sf_AdvDiffZ_nl(:,:)
  
  real(8), allocatable  :: fs_VelX_nl(:,:)
  real(8), allocatable  :: sf_VelZ_nl(:,:)
  real(8), allocatable  :: fs_VelX_al(:,:)
  real(8), allocatable  :: sf_VelZ_al(:,:)

  real(8), allocatable  :: ss_PotTemp_nl(:,:)
  real(8), allocatable  :: ss_Exner_nl(:,:)
  real(8), allocatable  :: ss_PotTemp_al(:,:)
  real(8), allocatable  :: ss_Exner_al(:,:)

  real(8), allocatable  :: ss_Km_al(:,:)
  real(8), allocatable  :: ss_Kh_al(:,:)
  real(8), allocatable  :: ss_Km_nl(:,:)
  real(8), allocatable  :: ss_Kh_nl(:,:)

  real(8), allocatable  :: ss_MixRtSat_nl(:,:)   !$BK0OB?e>x5$:.9gHf(B [t=n$B&$(Bt]
  real(8), allocatable  :: ss_MixRtV_al(:,:) !$B?e>x5$:.9gHf(B [t=(n-1)$B&$(Bt]
  real(8), allocatable  :: ss_MixRtV_nl(:,:) !$B?e>x5$:.9gHf(B [t=n$B&$(Bt]
  real(8), allocatable  :: ss_MixRtC_al(:,:) !$B?e>x5$:.9gHf(B [t=(n-1)$B&$(Bt]
  real(8), allocatable  :: ss_MixRtC_nl(:,:) !$B?e>x5$:.9gHf(B [t=n$B&$(Bt]
  real(8), allocatable  :: ss_MixRtR_al(:,:)  !$B?e>x5$:.9gHf(B [t=(n-1)$B&$(Bt]
  real(8), allocatable  :: ss_MixRtR_nl(:,:)  !$B?e>x5$:.9gHf(B [t=n$B&$(Bt]

  real(8), allocatable  :: sf_Buoy_nl(:,:) ! $B1tD>J}8~$N1?F0J}Dx<0$NIbNO9`(B [t=n$B&$(Bt]
  !--- $B>xH/$K$h$k1+?e$+$i?e>x5$$X$NJQ49(B
  real(8), allocatable  :: &
       & ss_EVrv_nl(:,:), & 
       !--- $BJ;9g@.D9$K$h$k1@?e$+$i1+?e$X$NJQ49(B
       & ss_CNcr_nl(:,:),&
       !--- $B6E7k$K$h$k?e>x5$$+$i1@?e$X$NJQ49(B
       & ss_CLcr_nl(:,:),& 
       !--- $B1+N3=*C<B.EY(B
       & ss_VelZRain_nl(:,:),& 
       !--- $B6E7k$K$h$k?e>x5$$+$i1@?e$X$NJQ49(B. 
       & ss_PRr_nl(:,:) 

  real(8)               :: ReStartTime(2)
  real(8)               :: Time
  integer               :: tau


!!!
!!!$B=i4|2=(B
!!!
  !--- I/O $B%U%!%$%kL>$N=i4|2=(B
  call fileset_init

  !--- $B%G%P%0@_Dj$N=i4|2=(B
  call debugset_init(cfgfile)

  !--- $BJ*M}NL$N=i4|2=(B
  call physset_init(cfgfile)
  
  !--- $B3J;RE@>pJs$N=i4|2=(B
  call gridset_init(cfgfile)
  
  !--- $B;~4V@QJ,$N@_Dj$N=i4|2=(B
  call timeset_init(cfgfile)
  
  !--- $B<B83L>$N=i4|2=(B
  call nameset_init(cfgfile)
  
  !--- $B7W;;$N@_Dj$rFI$_9~$`(B
  call arareset_init(cfgfile)

  !--- $B6-3&>r7o$r@_Dj(B
  call bcset_init(cfgfile)

  !--- $B<B83@_Dj$rFI$_9~$`(B
  call basicset_calc_init(cfgfile)

  !--- $B<B83@_Dj$rFI$_9~$`(B
  call disturbset_calc_init(cfgfile)
  
  !--- $B9TNs7W;;%i%$%V%i%j$N=i4|2=(B. 
  !--- $B0z?t$O%9%+%i!<$N(B z $BJ}8~$N7W;;NN0h$NBg$-$5(B
  call linlib_init(cfgfile, RegZMax - RegZMin)
  

!!!
!!!$BJQ?t$N=i4|2=(B
!!!  
  !--- $BG[Ns$N3d$jEv$F(B, $B=i4|2=(B
  call ArareAlloc

  !--- $B>qMp>l$N=i4|2=(B
  !$B:.9gHf$K4X$7$F$O4pK\>l$r4^$a$?CM$G2r$/$?$a(B, $B4pK\>l$NCM$rB-$7$F$*$/(B
  ss_Exner_nl   = ss_ExnerDisturb
  ss_PotTemp_nl = ss_PotTempDisturb
  fs_VelX_nl    = fs_VelXDisturb
  sf_VelZ_nl    = sf_VelZDisturb
  ss_MixRtV_nl = ss_MixRtVDisturb + ss_MixRtVBasicZ
  ss_MixRtC_nl = ss_MixRtCDisturb + ss_MixRtCBasicZ
  ss_MixRtR_nl = ss_MixRtRDisturb + ss_MixRtRBasicZ

!!!
!!!$B?tCM@QJ,(B. 1 $B%9%F%C%WJ,$@$12s$9(B. 
!!!
  !--- $B12G4@-78?t(B, $B123H;678?t$N7W;;(B
  call EddyViscosity(                                     &
       & ss_Km_nl,                                        & !$B=i4|CM$O%<%m(B
       & DelTimeLong,                                     & 
       & fs_VelX_nl, sf_VelZ_nl, ss_Km_nl,                & !$B0\N.(B
       & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl,           & !$B@8@.(B, $B3H;6(B, $B>C;6(B
       & ss_Km_nl, ss_Exner_nl,                           & !$B@8@.(B, $B3H;6(B, $B>C;6(B
       & ss_MixRtV_nl, ss_MixRtC_nl,            & !$B@8@.(B, $B3H;6(B, $B>C;6(B
       & ss_MixRtR_nl,                                &
       & ss_Km_al, ss_Kh_al )

  !--- $BD9$$;~4V%9%F%C%W$G$N290L$N7W;;(B
!  call Scalar(                                  & 
!       & ss_PotTemp_nl,                         &
!       & DelTimeLong,                           &
!       & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl, & !$B0\N.(B
!       & ss_PotTemp_nl, ss_Kh_nl,               & !$B@8@.(B, $BMpN.3H;6(B, $B?tCMG4@-(B
!       & ss_PotTemp_al )

  !=== $BCH$+$$1+$N%Q%i%a%?%j%<!<%7%g%s(B
  call WarmRainPrm( &
       & DelTimeLong, & 
       & fs_VelX_nl, sf_VelZ_nl, ss_Exner_nl, &
       & ss_PotTemp_nl, ss_PotTemp_nl, &
       & ss_MixRtV_nl, ss_MixRtV_nl, &
       & ss_MixRtC_nl, ss_MixRtC_nl, &
       & ss_MixRtR_nl,  ss_MixRtR_nl, &
       & ss_Kh_nl, &
       & ss_PotTemp_al, &
       & ss_MixRtV_al, &
       & ss_MixRtC_al, &
       & ss_MixRtR_al, &
       & ss_EVrv_nl, & 
       & ss_CNcr_nl,&
       & ss_CLcr_nl,& 
       & ss_VelZRain_nl,& 
       & ss_PRr_nl, &
       & ss_MixRtSat_nl  )
  
  !--- $BD9$$;~4V%9%F%C%W$G$NB.EY(B u $B$N0\N.(B, $B3H;6(B, $BG4@-(B
  call AdvectDiffuseX(                     &
       & fs_VelX_nl, sf_VelZ_nl,           & !$B0\N.(B
       & fs_VelX_nl, sf_VelZ_nl, ss_Km_nl, & !$BMpN.3H;6(B, $B?tCMG4@-(B
       & fs_AdvDiffX_nl )

  !--- $BD9$$;~4V%9%F%C%W$G$NB.EY(B w $B$N0\N.(B, $B3H;6(B, $BG4@-(B
  call AdvectDiffuseZ(                          &
       & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl, & !$B0\N.(B, $BIbNO(B
       & fs_VelX_nl, sf_VelZ_nl, ss_Km_nl,      & !$BMpN.3H;6(B, $B?tCMG4@-(B
       & ss_MixRtV_nl, ss_MixRtC_nl, ss_MixRtR_nl, &
       & sf_Buoy_nl, &
       & sf_AdvDiffZ_nl )
  
  !--- $BC;$$%?%$%`%9%F%C%W$N=i4|CM$r:n$k(B
  fs_VelX_ns  = fs_VelX_nl
  sf_VelZ_ns  = sf_VelZ_nl
  ss_Exner_ns = ss_Exner_nl 
  
  !--- $BC;$$%?%$%`%9%F%C%W$G$N@QJ,(B
  do tau = 1, NstepShort / 2
     !--- $BB.EY(B u $B$N7W;;(B
     call VelocityX(                                             &
          & fs_VelX_ns,                                          &
          & DelTimeShort,                                        &
          & fs_AdvDiffX_nl, fs_VelX_ns, sf_VelZ_ns, ss_Exner_ns, &
          & fs_VelX_as )
     
     !--- $B%(%/%9%J!<4X?t$N7W;;(B
     call Exner( &
          & sf_AdvDiffZ_nl, fs_VelX_ns, fs_VelX_as, sf_VelZ_ns, ss_Exner_ns, &
          & ss_Exner_as )
     
     !--- $BB.EY(B w $B$N7W;;(B
     call VelocityZ(  &
          & sf_VelZ_nl, &
          & DelTimeShort,    &
          & sf_AdvDiffZ_nl, fs_VelX_ns, sf_VelZ_ns, ss_Exner_ns, ss_Exner_as, &
          & sf_VelZ_as )
     
     !--- $B%k!<%W$r2s$9$?$a$N=hCV(B
     ss_Exner_ns  = ss_Exner_as 
     fs_VelX_ns   = fs_VelX_as
     sf_VelZ_ns   = sf_VelZ_as
  end do
     
  !--- $B:G=*E*$JB.EY$rD9$$;~4V%9%F%C%W$G$N$b$N$H$_$J$9(B
  ss_Exner_al  = ss_Exner_as 
  fs_VelX_al   = fs_VelX_as
  sf_VelZ_al   = sf_VelZ_as     

  !--- $B%U%!%$%k=PNO(B
  ReStartTime(1) = 0.0d0
  ReStartTime(2) = DelTimeLong
  call MakeReStartFile( ReStartFile, ReStartTime,  &
       & fs_VelX_nl,    sf_VelZ_nl,  ss_Exner_nl,  &
       & ss_PotTemp_nl, ss_Km_nl,    ss_Kh_nl,     &
       & ss_MixRtSat_nl, ss_MixRtV_nl,       &
       & ss_MixRtC_nl, ss_MixRtR_nl,      &
       & fs_VelX_al,    sf_VelZ_al,  ss_Exner_al,  &
       & ss_PotTemp_al, ss_Km_al,    ss_Kh_al,     &
       & ss_MixRtV_al,                        &
       & ss_MixRtC_al, ss_MixRtR_al )

contains


!!!
!!!$BG[Ns$N3d$jEv$F(B, $B=i4|2=(B
!!!
  subroutine ArareAlloc

    call BeginSub("ArareAlloc", &
&                 fmt="%c",     &
&                 c1="Allocate and initialize allocatable variables.")

    allocate(ss_Exner_as(DimXMin:DimXMax, DimZMin:DimZMax),  &
         & fs_VelX_as(DimXMin:DimXMax, DimZMin:DimZMax)  , &
         & sf_VelZ_as(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTemp_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTemp_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_AdvDiffX_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_AdvDiffZ_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_MixRtV_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_MixRtV_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_MixRtC_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_MixRtC_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_MixRtR_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_MixRtR_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_MixRtSat_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_Buoy_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_EVrv_nl(DimXMin:DimXMax, DimZMin:DimZMax), & 
         & ss_CNcr_nl(DimXMin:DimXMax, DimZMin:DimZMax),&
         & ss_CLcr_nl(DimXMin:DimXMax, DimZMin:DimZMax),& 
         & ss_VelZRain_nl(DimXMin:DimXMax, DimZMin:DimZMax),& 
         & ss_PRr_nl(DimXMin:DimXMax, DimZMin:DimZMax), &         
         & ss_Km_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Kh_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Km_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Kh_nl(DimXMin:DimXMax, DimZMin:DimZMax) )

    fs_VelX_al = 0.0d0
    fs_VelX_nl = 0.0d0

    sf_VelZ_al = 0.0d0
    sf_VelZ_nl = 0.0d0

    ss_Exner_al = 0.0d0
    ss_Exner_nl = 0.0d0

    ss_PotTemp_al = 0.0d0
    ss_PotTemp_nl = 0.0d0

    fs_VelX_as = 0.0d0
    fs_VelX_ns = 0.0d0

    sf_VelZ_as = 0.0d0
    sf_VelZ_ns = 0.0d0

    ss_Exner_as = 0.0d0
    ss_Exner_ns = 0.0d0

    fs_AdvDiffX_nl = 0.0d0
    sf_AdvDiffZ_nl = 0.0d0

    ss_MixRtSat_nl = 0.0d0
    ss_MixRtV_al = 0.0d0 
    ss_MixRtV_nl = 0.0d0
    ss_MixRtC_al = 0.0d0
    ss_MixRtC_nl = 0.0d0
    ss_MixRtR_al  = 0.0d0
    ss_MixRtR_nl  = 0.0d0

    sf_Buoy_nl     = 0.0d0
    ss_EVrv_nl     = 0.0d0
    ss_CNcr_nl     = 0.0d0
    ss_CLcr_nl     = 0.0d0
    ss_VelZRain_nl = 0.0d0
    ss_PRr_nl      = 0.0d0
    
    ss_Km_nl = 0.0d0
    ss_Kh_nl = 0.0d0

    ss_Km_al = 0.0d0
    ss_Kh_al = 0.0d0

    Time = 0.0d0

    call EndSub("ArareAlloc")

  end subroutine ArareAlloc


end program ArareInit
